#include <fstream>
#include <iostream>
#include <iterator>
#include <list>
#include <vector>
#include <sys/stat.h>
#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string>

#include "../bb/stats.hpp"
tm_stats g_counter, c_counter;

#include "../bb/infinite_tape.hpp"
#include "../bb/state.hpp"
#include "../bb/turing_machine.hpp"
#include "../bb/non_halt_detection.hpp"
#include "../bb/non_halt_data_structures.hpp"
#include "../bb/machine_storage.hpp"
#include "../bb/watch.hpp"

int main()
{
	/*turing_machine<unsigned short> machine(5,0);

	machine.set_halt_state(4);

	machine.add_write_transition(0,0,1,1);
	machine.add_move_transition(0,1, turing_machine<unsigned short>::left, 1);
	machine.add_move_transition(1,0, turing_machine<unsigned short>::left, 1);
	machine.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine.add_move_transition(2,0, turing_machine<unsigned short>::right, 3);
	machine.add_write_transition(3,0,1,0);
	machine.add_write_transition(3,1,0,2);

	if(counter(machine, 5000))
		std::cout << "yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine2(6,0);

	machine2.set_halt_state(5);

	machine2.add_write_transition(0,0,1,1);
	machine2.add_write_transition(1,0,1,2);
	machine2.add_move_transition(1,1, turing_machine<unsigned short>::right, 1);
	machine2.add_move_transition(2,0, turing_machine<unsigned short>::left, 4);
	machine2.add_move_transition(2,1, turing_machine<unsigned short>::left, 3);
	machine2.add_write_transition(3,1,0,2);
	machine2.add_move_transition(4,0, turing_machine<unsigned short>::right, 0);
	machine2.add_write_transition(4,1,0,2);

	if(counter(machine2, 5000))
		std::cout << "yes" << std::endl << std::endl;

	//machine2.printTMO(std::cout);
	//machine2.reverseMachine().printTMO(std::cout);

	turing_machine<unsigned short> machine3(6,0);

	machine3.set_halt_state(5);

	machine3.add_write_transition(0,0,1,0);
	machine3.add_move_transition(0,1, turing_machine<unsigned short>::right,1);
	machine3.add_move_transition(1,0, turing_machine<unsigned short>::right, 2);
	machine3.add_write_transition(2,0,1,3);
	machine3.add_write_transition(2,1,0,1);
	machine3.add_move_transition(3,0, turing_machine<unsigned short>::left, 4);
	machine3.add_move_transition(3,1, turing_machine<unsigned short>::left, 3);
	machine3.add_move_transition(4,0, turing_machine<unsigned short>::left, 4);
	machine3.add_move_transition(4,1, turing_machine<unsigned short>::right, 1);

	if(counter(machine3, 5000))
		std::cout << "yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine4(6,0);

	machine4.set_halt_state(5);

	machine4.add_write_transition(0,0,1,0);
	machine4.add_move_transition(0,1, turing_machine<unsigned short>::right,1);
	machine4.add_move_transition(1,0, turing_machine<unsigned short>::left, 2);
	machine4.add_write_transition(1,1,0,3);
	machine4.add_write_transition(2,0,1,3);
	machine4.add_move_transition(2,1, turing_machine<unsigned short>::left ,2);
	machine4.add_move_transition(3,0, turing_machine<unsigned short>::right, 0);
	machine4.add_move_transition(3,1, turing_machine<unsigned short>::right, 4);
	machine4.add_move_transition(4,1, turing_machine<unsigned short>::right, 1);

	if(alternateChristmasTree(machine4, 12000))
		std::cout << "machine4 yes" << std::endl << std::endl;*/

	/*turing_machine<unsigned short> machine5(6,0);

	machine5.set_halt_state(5);

	machine5.add_write_transition(0,0,1,1);
	machine5.add_move_transition(0,1, turing_machine<unsigned short>::right,0);
	machine5.add_move_transition(1,0, turing_machine<unsigned short>::right, 4);
	machine5.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine5.add_write_transition(2,0,1,3);
	machine5.add_move_transition(3,0, turing_machine<unsigned short>::left, 1);
	machine5.add_move_transition(3,1, turing_machine<unsigned short>::left, 4);
	machine5.add_move_transition(4,0, turing_machine<unsigned short>::right, 0);
	machine5.add_write_transition(4,1,0,3);

	if(leaningChristmasTree(machine5, 5000))
		std::cout << "machine5 yes" << std::endl << std::endl;*/

	/*turing_machine<unsigned short> machine6(6,0);

	machine6.set_halt_state(5);

	machine6.add_write_transition(0,0,1,1);
	machine6.add_move_transition(0,1, turing_machine<unsigned short>::left,0);
	machine6.add_move_transition(1,0, turing_machine<unsigned short>::right, 4);
	machine6.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine6.add_move_transition(2,0, turing_machine<unsigned short>::left, 2);
	machine6.add_move_transition(2,1, turing_machine<unsigned short>::right, 3);
	machine6.add_write_transition(3,0,1,0);
	machine6.add_move_transition(3,1, turing_machine<unsigned short>::right, 1);
	machine6.add_move_transition(4,0, turing_machine<unsigned short>::left, 3);

	if(tripleSweepChristmasTree(machine6, 20000))
		std::cout << "machine6 yes" << std::endl << std::endl;*/

	/*turing_machine<unsigned short> machine7(6,0);

	machine7.set_halt_state(5);

	machine7.add_write_transition(0,0,1,1);
	machine7.add_move_transition(0,1, turing_machine<unsigned short>::left,1);
	machine7.add_write_transition(1,0,1,0);
	machine7.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine7.add_move_transition(2,0, turing_machine<unsigned short>::right, 3);
	machine7.add_move_transition(2,1, turing_machine<unsigned short>::right, 4);
	machine7.add_move_transition(3,0, turing_machine<unsigned short>::right, 4);
	machine7.add_move_transition(4,0, turing_machine<unsigned short>::right, 1);
	machine7.add_write_transition(4,1,0,3);

	if(leaningChristmasTree(machine7, 20000))
		std::cout << "machine7 yes" << std::endl << std::endl;*/

	/*turing_machine<unsigned short> machine8(6,0);

	machine8.set_halt_state(5);

	machine8.add_write_transition(0,0,1,0);
	machine8.add_move_transition(0,1, turing_machine<unsigned short>::right,1);
	machine8.add_write_transition(1,0,1,2);
	machine8.add_move_transition(1,1, turing_machine<unsigned short>::right, 4);
	machine8.add_move_transition(2,0, turing_machine<unsigned short>::right, 0);
	machine8.add_move_transition(2,1, turing_machine<unsigned short>::left, 3);
	machine8.add_move_transition(3,0, turing_machine<unsigned short>::left, 2);
	machine8.add_write_transition(3,1,0,4);
	machine8.add_move_transition(4,0, turing_machine<unsigned short>::right, 1);

	if(alternateChristmasTree(machine8, 100000))
		std::cout << "machine8 yes" << std::endl << std::endl;*/

	/*turing_machine<unsigned short> machine8(6,0);

	machine8.set_halt_state(5);

	machine8.add_write_transition(0,0,1,1);
	machine8.add_move_transition(0,1, turing_machine<unsigned short>::right,1);
	machine8.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine8.add_write_transition(2,0,1,3);
	machine8.add_move_transition(2,1, turing_machine<unsigned short>::right, 0);
	machine8.add_move_transition(3,0, turing_machine<unsigned short>::right, 0);
	machine8.add_move_transition(3,1, turing_machine<unsigned short>::left, 4);
	machine8.add_move_transition(4,0, turing_machine<unsigned short>::right, 0);
	machine8.add_move_transition(4,1, turing_machine<unsigned short>::left, 3);

	if(alternateChristmasTree(machine8, 100000))
		std::cout << "machine8 yes" << std::endl << std::endl;*/

	/*turing_machine<unsigned short> machine8(6,0);

	machine8.set_halt_state(5);

	machine8.add_write_transition(0,0,1,1);
	machine8.add_move_transition(0,1, turing_machine<unsigned short>::left,1);
	machine8.add_move_transition(1,0, turing_machine<unsigned short>::left,1);
	machine8.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine8.add_move_transition(2,0, turing_machine<unsigned short>::right, 3);
	machine8.add_move_transition(2,1, turing_machine<unsigned short>::left, 4);
	machine8.add_write_transition(3,0,1,2);
	machine8.add_write_transition(3,1,0,2);
	machine8.add_move_transition(4,0, turing_machine<unsigned short>::right, 0);

	if(counter(machine8, 100000))
		std::cout << "machine8 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine9(6,0);

	machine9.set_halt_state(5);

	machine9.add_write_transition(0,0,1,1);
	machine9.add_move_transition(0,1, turing_machine<unsigned short>::left,1);
	machine9.add_move_transition(1,0, turing_machine<unsigned short>::left,1);
	machine9.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine9.add_move_transition(2,0, turing_machine<unsigned short>::right, 3);
	machine9.add_move_transition(2,1, turing_machine<unsigned short>::left, 0);
	machine9.add_move_transition(3,0, turing_machine<unsigned short>::right, 4);
	machine9.add_write_transition(3,1,0,2);
	machine9.add_write_transition(4,0,1,2);

	if(counter(machine9, 100000))
		std::cout << "machine9 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_move_transition(0,1, turing_machine<unsigned short>::left,4);
	machine10.add_move_transition(1,0, turing_machine<unsigned short>::right,2);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::right, 3);
	machine10.add_move_transition(3,0, turing_machine<unsigned short>::left, 4);
	machine10.add_write_transition(3,1,0,1);
	machine10.add_move_transition(4,0, turing_machine<unsigned short>::left, 0);

	if(counter(machine10, 100000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_move_transition(0,1, turing_machine<unsigned short>::right,3);
	machine10.add_move_transition(1,0, turing_machine<unsigned short>::right,2);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::right, 3);
	machine10.add_move_transition(3,0, turing_machine<unsigned short>::left, 4);
	machine10.add_write_transition(3,1,0,1);
	machine10.add_move_transition(4,0, turing_machine<unsigned short>::left, 0);
	machine10.add_move_transition(4,1, turing_machine<unsigned short>::left, 4);

	if(counter(machine10, 100000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_move_transition(0,1, turing_machine<unsigned short>::left,2);
	machine10.add_move_transition(1,0, turing_machine<unsigned short>::right,3);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::left, 2);
	machine10.add_move_transition(2,1, turing_machine<unsigned short>::right, 1);
	machine10.add_move_transition(3,0, turing_machine<unsigned short>::right, 4);
	machine10.add_write_transition(4,0,1,0);
	machine10.add_write_transition(4,1,0,1);

	if(counter(machine10, 50000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	/*turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_move_transition(0,1, turing_machine<unsigned short>::left,4);
	machine10.add_move_transition(1,0, turing_machine<unsigned short>::left,4);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::left, 3);
	machine10.add_write_transition(3,0,1,0);
	machine10.add_move_transition(3,1, turing_machine<unsigned short>::right, 3);
	machine10.add_move_transition(4,0, turing_machine<unsigned short>::right, 3);
	machine10.add_write_transition(4,1,0,1);

	if(counter(machine10, 50000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right,2);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::right,3);
	machine10.add_write_transition(2,1,0,4);
	machine10.add_write_transition(3,0,1,4);
	machine10.add_move_transition(3,1, turing_machine<unsigned short>::right, 1);
	machine10.add_move_transition(4,0, turing_machine<unsigned short>::right, 2);
	machine10.add_move_transition(4,1, turing_machine<unsigned short>::left, 3);

	if(leaningChristmasTree(machine10, 50000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_write_transition(0,1,0,2);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right,2);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::right,3);
	machine10.add_move_transition(2,1, turing_machine<unsigned short>::left,3);
	machine10.add_write_transition(3,0,1,4);
	machine10.add_move_transition(3,1, turing_machine<unsigned short>::right, 1);
	machine10.add_move_transition(4,0, turing_machine<unsigned short>::left, 0);
	machine10.add_move_transition(4,1, turing_machine<unsigned short>::left, 4);

	if(leaningChristmasTree(machine10, 50000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine8(6,0);

	machine8.set_halt_state(5);

	machine8.add_write_transition(0,0,1,0);
	machine8.add_move_transition(0,1, turing_machine<unsigned short>::right,1);
	machine8.add_write_transition(1,0,1,2);
	machine8.add_move_transition(1,1, turing_machine<unsigned short>::right, 4);
	machine8.add_move_transition(2,0, turing_machine<unsigned short>::right, 0);
	machine8.add_move_transition(2,1, turing_machine<unsigned short>::left, 3);
	machine8.add_move_transition(3,0, turing_machine<unsigned short>::left, 2);
	machine8.add_write_transition(3,1,0,4);
	machine8.add_move_transition(4,0, turing_machine<unsigned short>::right, 1);

	if(multiSweepChristmasTree(machine8, 2, 100000))
	//if(alternateChristmasTree(machine8, 100000))
		std::cout << "machine8 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_move_transition(0,1, turing_machine<unsigned short>::left,1);
	machine10.add_move_transition(1,0, turing_machine<unsigned short>::left,1);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::right, 3);
	machine10.add_write_transition(3,0,1,0);
	machine10.add_move_transition(3,1, turing_machine<unsigned short>::left, 4);
	machine10.add_move_transition(4,0, turing_machine<unsigned short>::right, 4);
	machine10.add_write_transition(4,1,0,2);

	if(counter(machine10, 50000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_move_transition(0,1, turing_machine<unsigned short>::left,3);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::left, 0);
	machine10.add_write_transition(2,1,0,4);
	machine10.add_write_transition(3,0,1,4);
	machine10.add_move_transition(3,1, turing_machine<unsigned short>::left, 0);
	machine10.add_move_transition(4,0, turing_machine<unsigned short>::right, 2);
	machine10.add_move_transition(4,1, turing_machine<unsigned short>::right, 1);

	if(counter(machine10, 50000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_move_transition(0,1, turing_machine<unsigned short>::left,2);
	machine10.add_write_transition(1,0,1,2);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right,1);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::left, 2);
	machine10.add_move_transition(2,1,turing_machine<unsigned short>::right,3);
	machine10.add_move_transition(3,0,turing_machine<unsigned short>::right,4);
	machine10.add_write_transition(4,0,1,0);
	machine10.add_write_transition(4,1,0,3);

	if(counter(machine10, 50000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_move_transition(0,1, turing_machine<unsigned short>::left,1);
	machine10.add_move_transition(1,0, turing_machine<unsigned short>::left,4);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right,2);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::right,3);
	machine10.add_write_transition(3,0,1,0);
	machine10.add_write_transition(3,1,0,2);
	machine10.add_move_transition(4,0,turing_machine<unsigned short>::left,1);
	machine10.add_move_transition(4,1,turing_machine<unsigned short>::right,4);

	if(counter(machine10, 50000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_write_transition(0,1,0,1);
	machine10.add_move_transition(1,0, turing_machine<unsigned short>::left,3);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right,2);
	machine10.add_write_transition(2,0,1,3);
	machine10.add_move_transition(2,1, turing_machine<unsigned short>::right,0);
	machine10.add_move_transition(3,0, turing_machine<unsigned short>::right,1);
	machine10.add_move_transition(3,1,turing_machine<unsigned short>::left,4);
	machine10.add_move_transition(4,1,turing_machine<unsigned short>::left,3);

	if(counter(machine10, 50000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_write_transition(1,0,1,2);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right,1);
	machine10.add_move_transition(2,1, turing_machine<unsigned short>::left,3);
	machine10.add_move_transition(3,0, turing_machine<unsigned short>::right,0);
	machine10.add_move_transition(3,1, turing_machine<unsigned short>::left,4);
	machine10.add_move_transition(4,0,turing_machine<unsigned short>::left,3);
	machine10.add_write_transition(4,1,0,4);

	if(backTrack(machine10, 20))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,0);
	machine10.add_move_transition(0,1, turing_machine<unsigned short>::right,1);
	machine10.add_write_transition(1,0,1,2);
	machine10.add_write_transition(1,1,0,4);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::left,3);
	machine10.add_move_transition(2,1, turing_machine<unsigned short>::left,3);
	machine10.add_move_transition(3,0, turing_machine<unsigned short>::right,4);
	machine10.add_move_transition(3,1, turing_machine<unsigned short>::left,2);
	machine10.add_move_transition(4,0,turing_machine<unsigned short>::right,0);

	if(counter(machine10, 100000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_move_transition(0,1, turing_machine<unsigned short>::left,2);
	machine10.add_move_transition(1,0, turing_machine<unsigned short>::left,2);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right,1);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::left,4);
	machine10.add_move_transition(2,1, turing_machine<unsigned short>::left,3);
	machine10.add_move_transition(3,0, turing_machine<unsigned short>::right,3);
	machine10.add_move_transition(3,1, turing_machine<unsigned short>::left,0);
	machine10.add_move_transition(4,0,turing_machine<unsigned short>::left,3);

	if(multiSweepChristmasTree(machine10, 4, 200000))
		std::cout << "machine10 yes" << std::endl << std::endl;*/

	/*turing_machine<unsigned short> machine10(6,0);

	machine10.set_halt_state(5);

	machine10.add_write_transition(0,0,1,1);
	machine10.add_move_transition(0,1, turing_machine<unsigned short>::left,4);
	machine10.add_move_transition(1,0, turing_machine<unsigned short>::left,0);
	machine10.add_move_transition(1,1, turing_machine<unsigned short>::right,2);
	machine10.add_move_transition(2,0, turing_machine<unsigned short>::left,3);
	machine10.add_move_transition(2,1, turing_machine<unsigned short>::right,0);
	machine10.add_move_transition(3,0, turing_machine<unsigned short>::right,2);
	machine10.add_move_transition(3,1, turing_machine<unsigned short>::left,3);
	machine10.add_write_transition(4,1,0,1);

	if(nestedChristmasTree(machine10, 100000))
		std::cout << "machine10 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine11(6,0);

	machine11.set_halt_state(5);

	machine11.add_write_transition(0,0,1,1);
	machine11.add_write_transition(1,0,1,3);
	machine11.add_move_transition(1,1, turing_machine<unsigned short>::right,2);
	machine11.add_move_transition(2,0, turing_machine<unsigned short>::right,1);
	machine11.add_move_transition(2,1, turing_machine<unsigned short>::right,0);
	machine11.add_move_transition(3,0, turing_machine<unsigned short>::right,0);
	machine11.add_move_transition(3,1, turing_machine<unsigned short>::left,4);
	machine11.add_move_transition(4,0, turing_machine<unsigned short>::left,3);
	machine11.add_write_transition(4,1,0,2);

	if(nestedChristmasTree(machine11, 100000))
		std::cout << "machine11 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine12(6,0);

	machine12.set_halt_state(5);

	machine12.add_write_transition(0,0,1,1);
	machine12.add_move_transition(0,1, turing_machine<unsigned short>::left,4);
	machine12.add_move_transition(1,0, turing_machine<unsigned short>::left,4);
	machine12.add_move_transition(1,1, turing_machine<unsigned short>::right,2);
	machine12.add_write_transition(2,0,1,3);
	machine12.add_move_transition(3,0, turing_machine<unsigned short>::right,1);
	machine12.add_move_transition(3,1, turing_machine<unsigned short>::right,3);
	machine12.add_move_transition(4,0, turing_machine<unsigned short>::left,0);
	machine12.add_write_transition(4,1,0,4);

	if(nestedChristmasTree(machine12, 100000))
		std::cout << "machine12 yes" << std::endl << std::endl;
	std::cout << std::endl << std::endl;

	turing_machine<unsigned short> machine13(6,0);

	machine13.set_halt_state(5);

	machine13.add_write_transition(0,0,1,1);
	machine13.add_move_transition(0,1, turing_machine<unsigned short>::left,4);
	machine13.add_write_transition(1,0,1,2);
	machine13.add_move_transition(1,1, turing_machine<unsigned short>::right,1);
	machine13.add_move_transition(2,1, turing_machine<unsigned short>::right,3);
	machine13.add_write_transition(3,0,1,0);
	machine13.add_write_transition(3,1,0,4);
	machine13.add_move_transition(4,0, turing_machine<unsigned short>::right,2);
	machine13.add_move_transition(4,1, turing_machine<unsigned short>::left,0);

	if(nestedChristmasTree(machine13, 100000))
		std::cout << "machine13 yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine14(6,0);

	machine14.set_halt_state(5);

	machine14.add_write_transition(0,0,1,1);
	machine14.add_move_transition(1,0, turing_machine<unsigned short>::left,0);
	machine14.add_move_transition(1,1, turing_machine<unsigned short>::right,2);
	machine14.add_move_transition(2,0, turing_machine<unsigned short>::right,3);
	machine14.add_move_transition(2,1, turing_machine<unsigned short>::left,4);
	machine14.add_move_transition(3,0, turing_machine<unsigned short>::right,4);
	machine14.add_write_transition(3,1,0,1);
	machine14.add_move_transition(4,0, turing_machine<unsigned short>::left,4);
	machine14.add_move_transition(4,1, turing_machine<unsigned short>::left,1);

	if(leaningChristmasTree(machine14, 100000))
		std::cout << "machine14 yes" << std::endl << std::endl;*/

	turing_machine<unsigned short> machine14(6,0);

	machine14.set_halt_state(5);

	machine14.add_write_transition(0,0,1,1);
	machine14.add_write_transition(0,1,0,3);
	machine14.add_write_transition(1,0,1,2);
	machine14.add_move_transition(1,1, turing_machine<unsigned short>::right,1);
	machine14.add_move_transition(2,0, turing_machine<unsigned short>::right,3);
	machine14.add_move_transition(2,1, turing_machine<unsigned short>::right,2);
	machine14.add_move_transition(3,0, turing_machine<unsigned short>::left,4);
	machine14.add_move_transition(4,0, turing_machine<unsigned short>::left,0);
	machine14.add_move_transition(4,1, turing_machine<unsigned short>::left,4);

	if(leaningChristmasTree(machine14, 100000))
		std::cout << "machine14 yes" << std::endl << std::endl;

	return 0;
}
